Redmine - Feature #31128

Drop Ruby < 2.5 support
2019-04-01 00:32 - Marius BALTEANU

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Ruby support Estimated time: 0.00 hour
Target version: 5.0.0

Resolution: Fixed

Description

Rails 6 requires at least Ruby 2.5.0

root@85be5e8d7c3e: /work# bundle update
The dependency tzinfo-data (>= 0) will be unused by any of the platforms Bundler is installing for
Bundler is installing for ruby but the dependency is only for x86-mingw32, x64-mingw32, x86-mswi
n32. To add those platforms to the bundle, run “bundle lock --add-platform x86-mingw32 x64-mingw32
x86-mswin32" .
Fetching gem metadata from https://rubygems.org/..........
Fetching gem metadata from https://rubygems.org/.
Resolving dependencies...
Bundler could not find compatible versions for gem "ruby":
In Gemfile:
ruby

rails (= 6.0.0.beta3) was resolved to 6.0.0.beta3, which depends on
ruby (>= 2.5.0)

Related issues:

Related to Redmine - Feature #29914: Migrate to Rails 6.1 with Zeitwerk autol... Closed
Blocks Redmine - Patch #35000: Update SimpleCov to 0.21 Closed
Blocks Redmine - Patch #35025: Update capybara to 3.36 Closed

Associated revisions

Revision 20902 - 2021-04-01 18:20 - Go MAEDA
Drop Ruby < 2.5 support (#31128).

Revision 20903 - 2021-04-01 18:27 - Go MAEDA
Update .rubocop_todo.yml (#31128).

Revision 20904 - 2021-04-01 19:05 - Go MAEDA
Set TargetRubyVersion of RuboCop to 2.5 (#31128).

History

#1 - 2019-04-01 00:32 - Marius BALTEANU
- Copied from Feature #30356: Drop Ruby 2.2 support added

#2 - 2019-04-01 00:32 - Marius BALTEANU
- Copied from deleted (Feature #30356: Drop Ruby 2.2 support)

#3 - 2019-04-01 00:32 - Marius BALTEANU
- Related to Feature #29914: Migrate to Rails 6.1 with Zeitwerk autoloading added

#4 - 2020-04-19 13:54 - Marius BALTEANU

- Target version changed from Unplanned backlogs to 5.0.0

2025-05-02 1/3




#5 - 2021-03-29 06:05 - Go MAEDA

- File 0001-Drop-Ruby-2.5-Support.patch added

- File 0002-Update-TargetRubyVersion-of-RuboCop-to-2.5.patch added
The attached patches drop Ruby 2.4 support.

As Marius wrote, Rails 6 requires Ruby 2.5 or later. We have to migrate to Rails 6 in Redmine 5.0 because the support for Rails 5.2 which we are
currently using will end when Rails 7.0 (the next version of Rails) is released.

And Ruby 2.4 has already become EOL in March 2020.
#6 - 2021-04-01 19:05 - Go MAEDA
- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Done.

#7 - 2021-04-02 04:07 - Go MAEDA
- Blocks Patch #35000: Update SimpleCov to 0.21 added

#8 - 2021-04-04 02:56 - Go MAEDA
- Blocks Patch #35025: Update capybara to 3.36 added

#9 - 2021-08-11 19:15 - Marius BALTEANU
- Status changed from Closed to Reopened
I'm reopening this to discuss the option to drop support for Ruby 2.5 as well.
| wrote in #32424+#note-62:
Rails 6.1 and Redmine 5.0.0 supports minimum Ruby 2.5, but the CommonMarker latest version (0.22.0) supports minimum Ruby 2.6.
We should drop support for Ruby 2.5 or we should stick with commonmarker version 0.21.0 if ruby is 2.5? Note that Ruby 2.5 is EOL since
March this year.
Holger Just wrote in #32424#note-63:
| would be fine with requiring Ruby 2.6 for Redmine 5.0.
Some notes here:
Debian 11 Bullseye is going to ship with Ruby 2.7 on August 14.
Ubuntu >= 20 ships with Ruby 2.7
Debian 10 (Buster) and Ubuntu 18.04 (bionic) still ship Ruby 2.5. Users would have to either use a custom Ruby or stay on Redmine 4.2

CentOS 8 / Redhat 8 can install Ruby 2.7 with dnf.
For Windows, there are usable installers for current Rubies.

With this change, we would thus cut off Debian 10 and Ubuntu 18.04 with their respective system-default Rubies. They can install a custom
Ruby with rvm / rbenv / ruby-install though.

#10 - 2021-08-14 07:43 - Mischa The Evil

It might be a good idea to even drop support for 2.6 too if this can be done without any additional cost (which seems to be the case given the info
provided by Holger).

Already requiring Ruby 2.7 for Redmine 5.x.x will ease the future upgrade to Rails 7.x, which will require 2.7.0+ whereas 3.0+ would be preferred®,
thus easing an upgrade from Redmine 5.x to 6.x (where 6.x is given to be running on Rails 7.x).

' source: Ruby on Rails 7.0 Release Notes

#11 - 2021-10-27 05:59 - Heart Kotoishi

| think you should think about stopping support for ruby 2.6 as well as ruby 2.5.
Redmine is a huge project that takes more than a year for major updates.

2025-05-02 2/3


https://www.redmine.org/issues/32424#note-62
https://www.redmine.org/versions/155
https://github.com/gjtorikian/commonmarker
https://github.com/gjtorikian/commonmarker/blob/v0.22.0/commonmarker.gemspec#L24
https://www.ruby-lang.org/en/downloads/branches/
https://www.redmine.org/issues/32424#note-63
https://edgeguides.rubyonrails.org/7_0_release_notes.html

In fact, it took 1 year and 2 months from the release of version 4.1.0 to the release of version 4.2.0.

We don't know when version 5.0 will be released, but assuming we need 1 year and 6 months from the release of version 4.2, version 5.0 will be
released around September 2022.

Then, by the time version 5.0 is released, ruby 2.6 series will be no longer supported.

(The ruby developers announced when they released ruby 2.6.8 that they will stop supporting ruby 2.6 series around March 2022.)

Even if you don't end support for the ruby 2.6 series with version 5.0.0, | think it would be better to end support with a major update such as version
5.1.0.

#12 - 2021-11-18 00:40 - Marius BALTEANU

- Status changed from Reopened to Closed

The code base supports Ruby 2.5 with few changes that are already committed, so we're going to stick with it. We will drop the support at the same
time with Rails.

Files
0001-Drop-Ruby-2.5-Support.patch 1.4 KB 2021-03-29 Go MAEDA
0002-Update-TargetRubyVersion-of-RuboCop-to-2.5.patch 2KB 2021-03-29 Go MAEDA
